<template>
  <div class="container">
    <form @submit.prevent="shortenUrl" :class="$mq">
      <div class="input-group">
        <input type="text" v-model="longUrl" placeholder="Enter a url to shorten" />
        <button type="submit" class="input-addon btn btn-blue">Shorten</button>
      </div>
    </form>
    <div class="alert alert-success" :class="$mq" v-if="!!shortUrl">
      <span class="short_url">{{ shortUrl }}</span>
      <button class="btn btn-green" v-clipboard:copy="shortUrl">
        <i class="fa fa-fw fa-copy"></i>Copy to Clipboard
      </button>
    </div>
    <div class="alert alert-error" :class="$mq" v-if="!!error">
      <span class="short_url" v-html="error">An error occured. Please try again later.</span>
    </div>
  </div>
</template>

<script>
export default {
  data () {
    return {
      longUrl: "",
      shortUrl: null,
      error: null
    }
  },
  methods: {
    shortenUrl() {
      this.$http.post("/short_links", { short_link: { url: this.longUrl } })
      .then( (response) => {
        this.error = null
        this.shortUrl = response.data.short_link.short_url
      })
      .catch( (error) => {
        let errors = error.response.data.errors
        this.shortUrl = null
        if (!!errors) {
          this.error = errors.join("; ")
        } else {
          this.error = 'An error occured, please try again later'
        }
      })
    }
  }
}
</script>

<style lang='sass' scoped>
.container
  display: flex
  justify-content: center
  align-items: center
  flex-direction: column
  height: 90%
  form
    width: 50%
    &.xs,&.sm
      width: 90%
  .alert
    width: 35%
    display: flex
    padding: 15px
    justify-content: space-around
    align-items: center
    margin-top: 20px
    &.xs,&.sm
      width: 80%
    .short_url
      padding-right: 20px
  .input-group
    display: flex
    input
      flex: 1
      line-height: 32px
      padding: 14px 23px
      width: 67%
      font-size: 18px
    .input-addon
      border-radius: 0
</style>
